Index: /trunk/src/yulectl.c
===================================================================
--- /trunk/src/yulectl.c	(revision 584)
+++ /trunk/src/yulectl.c	(revision 1)
@@ -24,5 +24,4 @@
 #include <stdlib.h>
 #include <string.h> 
-#include <ctype.h>
 #include <errno.h>
 
@@ -42,14 +41,9 @@
 #define SH_MAXMSG 209
 
-#if !defined(HAVE_GETPEEREID) && !defined(SO_PEERCRED) && \
-  !defined(HAVE_STRUCT_CMSGCRED) && !defined(HAVE_STRUCT_FCRED) && \
-  !(defined(HAVE_STRUCT_SOCKCRED) && defined(LOCAL_CREDS))
-#define SH_REQ_PASSWORD 1
-#endif
-
-#define SH_PW_SIZE 15
-
 static int    sock     = -1;
-static char   password[SH_PW_SIZE] = "";
+static char * sockname = NULL;
+
+static char   password[15] = "";
+
 static int    verbose = 0;
 
@@ -92,8 +86,15 @@
 
 
-static int 
-create_unix_socket ()
+int 
+make_named_socket (char * sockname)
 {
   int sock;
+
+#if 0
+  struct sockaddr_un name;
+  size_t size;
+#else
+  (void) sockname;
+#endif
 
   /* Create the socket. */
@@ -106,8 +107,27 @@
     }
 
+#if 0
+  /* Bind a name to the socket. */
+  name.sun_family = AF_FILE;
+  strcpy (name.sun_path, sockname);
+
+  /* The size of the address is
+     the offset of the start of the filename,
+     plus its length,
+     plus one for the terminating null byte. */
+  size = (offsetof (struct sockaddr_un, sun_path)
+          + strlen (name.sun_path) + 1);
+
+  if (bind (sock, (struct sockaddr *) &name, size) < 0)
+    {
+      perror (_("ERROR: bind"));
+      return -1;
+    }
+#endif
+
   return sock;
 }
 
-static void
+void
 termination_handler (int signum)
 {
@@ -118,23 +138,17 @@
 	fprintf(stdout, _("# Terminated on signal %d\n"), signum);
     }
-  if (sock   >= 0 ) 
-    close  (sock);
+#if 0
+  if (sockname != NULL) unlink (sockname);
+#endif
+  if (sock   >= 0 ) close  (sock);
+
   return;
 }
 
-static char * safe_copy(char * to, const char * from, size_t size)
-{
-  if (to && from && (size > 0))
-    {
-      strncpy (to, from, size-1);
-      to[size-1] = '\0';
-    }
-  return to;
-}
- 
-
-static int send_to_server (char * serversock, char * message)
+
+int send_to_server (char * serversock, char * message)
 {
   struct sockaddr_un name;
+  /* size_t size; */
   int size;
   int nbytes;
@@ -143,11 +157,5 @@
    */
   name.sun_family = AF_UNIX;
-  memcpy(name.sun_path, serversock, sizeof(name.sun_path));
-  name.sun_path[sizeof(name.sun_path)-1] = '\0';
-  if (strlen(serversock) > strlen(name.sun_path))
-    {
-      perror (_("ERROR: socket path too long"));
-      return -1;
-    }
+  strncpy (name.sun_path, serversock, sizeof(name.sun_path) - 1);
   size = (offsetof (struct sockaddr_un, sun_path)
           + strlen (name.sun_path) + 1);
@@ -160,7 +168,10 @@
     }
 
-  /* Send the data. 
+  /* Send the datagram. 
+  nbytes = sendto (sock, message, strlen (message) + 1, 0,
+                   (struct sockaddr *) & name, size);
    */
   nbytes = send (sock, message, strlen (message) + 1, 0);
+
   if (nbytes < 0)
     {
@@ -194,5 +205,5 @@
 }
 
-static int recv_from_server (char * message)
+int recv_from_server (char * message)
 {
   int nbytes = 0;
@@ -200,20 +211,48 @@
   int  num = 0;
   int  good = -1;
+  int  islist = 0;
   char * p;
 
   if (password[0] == '\0')
-    p = message;
-  else
-    p = &message[strlen(password)+1];
-
-  if (0 == strncmp(p, _("PROBE"), 5) ||
-      0 == strncmp(p, _("LIST"),  4))
+    {
+      if (message[0] == 'L' && message[1] == 'I' &&
+	  message[2] == 'S' && message[3] == 'T')
+	{
+	  islist = 1;
+	}
+      if (message[0] == 'P' && message[1] == 'R' &&
+	  message[2] == 'O' && message[3] == 'B' && message[4] == 'E' )
+	{
+	  islist = 1;
+	}
+    }
+  else
+    {
+      p = &message[strlen(password)+1];
+      if (p[0] == 'L' && p[1] == 'I' &&
+	  p[2] == 'S' && p[3] == 'T')
+	{
+	  islist = 1;
+	}
+      if (p[0] == 'P' && p[1] == 'R' &&
+	  p[2] == 'O' && p[3] == 'B' && p[4] == 'E' )
+	{
+	  islist = 1;
+	}
+    }
+
+  if (islist == 1)
     {
       do {
+	/*
+	nbytes = recvfrom (sock, recvmsg, SH_MAXMSG, 0, NULL, 0);
+	*/
 	nbytes = getline_from_server (sock, recvmsg, SH_MAXMSG);
 	if (nbytes < 0)
 	  {
 	    if (errno == EAGAIN)
-	      return 0;
+	      {
+		return 0;
+	      }
 	    else
 	      {
@@ -223,10 +262,11 @@
 	  }
 	else if (nbytes == 0)
-	  return 0;
-
+	  {
+	    return 0;
+	  }
 	if (recvmsg[0] == 'E' && recvmsg[1] == 'N' && recvmsg[2] == 'D')
 	  {
 	    if (verbose && (num == 0))
-	      fprintf (stdout, "%s", _("# There are no pending commands.\n"));
+	      fprintf (stdout, _("# There are no pending commands.\n"));
 	    return 0;
 	  }
@@ -237,4 +277,7 @@
   else
     {
+      /*
+      nbytes = recvfrom (sock, recvmsg, SH_MAXMSG, 0, NULL, 0);
+      */
       nbytes = recv (sock, recvmsg, SH_MAXMSG, 0);
       if (nbytes < 0)
@@ -247,19 +290,15 @@
   /* Print a diagnostic message. */
   if (password[0] == '\0')
-    good = strcmp (message, recvmsg);
-  else
-    good = strcmp (&message[strlen(password)+1], recvmsg);
+    {
+      good = strcmp (message, recvmsg);
+    }
+  else
+    {
+      good = strcmp (&message[strlen(password)+1], recvmsg);
+    }
 
   if (0 != good)
     {
-      if (0 == strncmp(recvmsg, _("!E:"), 3))
-	{ 
-	  fputs(recvmsg, stderr); 
-	  fputc('\n', stderr); 
-	}
-      else
-	{
-	  fputs (_("ERROR: Bounced message != original message.\n"), stderr);
-	}
+      fprintf (stderr, _("ERROR: Bounced message != original message.\n"));
       return -1;
     }
@@ -267,5 +306,5 @@
     {
       if (verbose)
-	fprintf (stdout, "%s", _("# Message received by server.\n"));
+	fprintf (stdout, _("# Message received by server.\n"));
     }
 
@@ -273,105 +312,31 @@
 }
 
-static int check_uuid(const char * in)
-{
-  int 		i;
-  const char	*cp;
-
-  if (!in || strlen(in) != 36)
-    return -1;
-  for (i=0, cp = in; i <= 36; i++,cp++) {
-    if ((i == 8) || (i == 13) || (i == 18) ||
-	(i == 23)) {
-      if (*cp == '-')
-	continue;
-      else
-	return -1;
-    }
-    if (i== 36)
-      if (*cp == 0)
-	continue;
-    if (!isxdigit(*cp))
-      return -1;
-  }
-  return 0;
-}
-
-static int check_command(const char * str)
-{
-  unsigned int i = 0;
-  char * commands[] = { N_("DELTA:"), N_("RELOAD"),  N_("STOP"), N_("SCAN"),
-			N_("CANCEL"), N_("LISTALL"), N_("LIST"), N_("PROBE"), NULL };
-
-  while (commands[i])
-    {
-      size_t len = strlen(_(commands[i]));
-
-      if (0 == strncmp(_(commands[i]), str, len))
-	{
-	  if (i == 0)
-	    {
-	      char * p = strchr(str, ':'); ++p;
-	      if ( 0 == check_uuid(p) )
-		return 0;
-	    }
-	  else
-	    {
-	      if (len == strlen(str))
-		return 0;
-	    }
-	}
-      ++i;
-    }
-
-  fprintf (stderr, _("ERROR: invalid command <%s>\n\n"), str);
-  return -1;
-}
-
-static void print_usage_and_exit(char * name, int exit_status)
+void usage(char * name)
 {
   printf(_("\nUsage : %s [-v][-s server_socket] -c command <client_hostname>\n\n"), 
 	 name);
 
-  printf("%s", _("Purpose : send commands to the server via a socket,\n"));
-  printf("%s", _("          in particular commands that the server would\n"));
-  printf("%s", _("          transfer to the client <client_hostname> when\n"));
-  printf("%s", _("          this client connects to deliver a message.\n\n"));
-  printf("%s", _("          If password is required, it is read from\n"));
-  printf("%s", _("          $HOME/.yulectl_cred or taken from the environment\n"));
-  printf("%s", _("          variable YULECTL_PASSWORD (not recommended).\n\n"));
-
-  printf("%s", _("Commands: RELOAD         reload configuration\n"));
-  printf("%s", _("          DELTA:<uuid>   load delta database with given uuid\n"));
-  printf("%s", _("          STOP           terminate\n"));
-  printf("%s", _("          SCAN           initiate file system check\n"));
-  printf("%s", _("          CANCEL         cancel pending command(s)\n"));
-  printf("%s", _("          LIST           list queued commands\n"));
-  printf("%s", _("          LISTALL        list queued and last sent commands\n"));
-  printf("%s", _("          PROBE          probe all clients for necessity of reload\n"));
-  exit(exit_status);
-}
-
-char * rtrim(char * str)
-{
-  size_t len;
-
-  if (!str) return str;
-
-  len = strlen(str);
-  while (len > 0)
-    {
-      --len;
-      if (str[len] == '\n' || str[len] == '\r')
-	str[len] = '\0';
-      else
-	break;
-    }
-  return str;
-}
-
-static int get_home(char * home, size_t size)
-{
+  printf(_("Purpose : send commands to the server via a socket,\n"));
+  printf(_("          in particular commands that the server would\n"));
+  printf(_("          transfer to the client <client_hostname> when\n"));
+  printf(_("          this client connects to deliver a message.\n\n"));
+
+  printf(_("Commands: RELOAD    <reload configuration>\n"));
+  printf(_("          STOP      <terminate>\n"));
+  printf(_("          CANCEL    <cancel previous command>\n"));
+  printf(_("          LIST      <list queued commands>\n"));
+  printf(_("          LISTALL   <list queued and last sent commands>\n"));
+  printf(_("          PROBE     <probe all clients for necessity of reload>\n"));
+  return;
+}
+
+void fixup_message (char * message)
+{
+  char message2[SH_MAXMSG];
+  char home[4096];
+  FILE * fp;
   struct passwd * pwent;
 
+  
   pwent = getpwuid(geteuid());
   if ((pwent == 0) || (pwent->pw_dir == NULL))
@@ -382,165 +347,99 @@
       if (NULL != getenv(_("HOME")))
 	{
-	  safe_copy(home, getenv(_("HOME")), size);
+	  strncpy(home, getenv(_("HOME")), 4096);
+	  home[4095] = '\0';
 	}
       else
 	{
 	  fprintf (stderr, _("ERROR: no home directory for euid %ld (tried $HOME and password database).\n"), (long) geteuid());
-	  return -1;
-	}
-    }
-  else
-    {
-      safe_copy(home, pwent->pw_dir, size);
-    }
-  return 0;
-}
-
-static int get_passwd(char * message2, size_t size)
-{
-  char home[4096];
-  FILE * fp;
-  char * pw;
-
-  /* 1) Password from environment
-   */
-  pw = getenv(_("YULECTL_PASSWORD"));
-  if (pw && strlen(pw) < SH_PW_SIZE)
-    {
-      strcpy(password, pw);
-      strcpy(message2, password);
-      return 0;
-    }
-
-  /* 2) Password from $HOME/.yule_cred
-   */
-  if (get_home(home, sizeof(home)) < 0)
-    return -1;
-
-  if ( (strlen(home) + strlen(_("/.yulectl_cred")) + 1) > sizeof(home))
-    {
-      fprintf (stderr, "%s", _("ERROR: path for $HOME is too long.\n"));
-      return -1;
+	  exit(EXIT_FAILURE);
+	}
+    }
+  else
+    {
+      strncpy(home, pwent->pw_dir, 4096);
+      home[4095] = '\0';
+    }
+
+  if ( (strlen(home) + strlen(_("/.yulectl_cred")) + 1) > 4096)
+    {
+      fprintf (stderr, _("ERROR: path for $HOME is too long.\n"));
+      exit(EXIT_FAILURE);
     }
   strcat(home, _("/.yulectl_cred"));
   fp = fopen(home, "r");
-
-#if defined(SH_REQ_PASSWORD)
   if (fp == NULL)
     {
-      if (errno == ENOENT) {
-	fprintf (stderr, 
-		 _("ERROR No password file (%s) exists\n"),
+      if (verbose && (errno == ENOENT))
+	fprintf (stdout, 
+		 _("# Password file (%s) missing\n"),
 		 home);
-      }
-      else {
-	fprintf (stderr, 
-		 _("ERROR: Password file (%s) not accessible for euid %ld uid %ld\n"),
+      else if (verbose)
+	fprintf (stdout, 
+		 _("# Password file (%s) not accessible for euid %ld uid %ld\n"),
 		 home, (long)geteuid(), (long)getuid());
-      }
-      return -1;
-    }
-#else
-  if (fp == NULL)
-    return 0;
-#endif
-
-  if (NULL == fgets(message2, size, fp))
-    {
-      fprintf (stderr,
+      return;
+    }
+  if (NULL == fgets(message2, SH_MAXMSG, fp))
+    {
+      fprintf (stderr, 
 	       _("ERROR: empty or unreadable password file (%s).\n"),
 	       home);
-      return -1;
-    }
-
-  (void) rtrim(message2);
-
-  if (strlen(message2) > (SH_PW_SIZE -1))
-    {
-      fprintf (stderr, "%s", 
+      exit(EXIT_FAILURE);
+    }
+  if (strlen(message2) > 15)
+    {
+      fprintf (stderr, 
 	       _("ERROR: Password too long (max. 14 characters).\n"));
-      return -1;
+      exit(EXIT_FAILURE);
+    }
+
+  if ( (0 != strlen(message2)) && ('\n' == message2[strlen(message2)-1]))
+    {
+      message2[strlen(message2)-1] = '\0';
     }
   strcpy(password, message2);
+  strcat(message2, "@");
   fclose(fp);
 
-  return 0;
-}
-
-static int fixup_message (char * message)
-{
-  char message_fixed[SH_MAXMSG] = { 0 };
-
-  if (get_passwd(message_fixed, sizeof(message_fixed)) < 0)
-    return -1;
-
-  if (strlen(message_fixed) > 0)
-    {
-      strcat(message_fixed, "@");
-
-      strncat(message_fixed, message, SH_MAXMSG - strlen(message_fixed) -1);
-      message_fixed[SH_MAXMSG-1] = '\0';
-      strcpy(message, message_fixed);
-    }
-  return 0;
-}
-
-static int fill_serversock(char * serversock, size_t size)
-{
-  int status;
-
+  strncat(message2, message, SH_MAXMSG - strlen(message2) -1);
+  message2[SH_MAXMSG-1] = '\0';
+  strcpy(message, message2);
+  return;
+}
+
+
+int
+main (int argc, char * argv[])
+{
+
+  char   message[SH_MAXMSG] = "";
+  char   clientcd[1024];
+  char   serversock[256];
+  int    status, size;
+  int    num = 1;
+  int    flag = 0;
+  
 #ifdef HAVE_VSNPRINTF
-  status = snprintf(serversock, size, _("%s/%s.sock"), 
+  status = snprintf(serversock, 256, _("%s/%s.sock"), 
 		    DEFAULT_PIDDIR, SH_INSTALL_NAME);
 #else
-  if ((strlen(DEFAULT_PIDDIR) + strlen(SH_INSTALL_NAME) + 1 + 6) > size)
-    status = -1;
-  else
-    status = sprintf (serversock, _("%s/%s.sock"), 
-		      DEFAULT_PIDDIR, SH_INSTALL_NAME);
-#endif
-
-  if ((status < 0) || (status > (int)(size-1)))
-    {
-      fprintf(stderr, _("ERROR: Path too long (maximum %d): %s/%s.sock\n"), 
-	      (int) (size-1), DEFAULT_PIDDIR, SH_INSTALL_NAME);
-      return -1;
-    }
-  return 0;
-}
-
-static void checklen(char * command, char * str, size_t maxlen)
-{
-  if (strlen(str) > maxlen) 
-    {
-      fprintf(stderr, _("ERROR: String too long (max %d): %s\n\n"), 
-	      (int) maxlen, str);
-      print_usage_and_exit (command, EXIT_FAILURE);
-    }
-  return;
-}
-
-static void checknull(char * command, char * str)
-{
-  if (str == NULL || str[0] == '\0') {
-    fprintf(stderr, "%s", _("ERROR: option with missing argument\n\n"));
-    print_usage_and_exit(command, EXIT_FAILURE);
-  }
-  return;
-}
-
-int
-main (int argc, char * argv[])
-{
-
-  char   message[SH_MAXMSG] = "";
-  char   serversock[256];
-  int    status;
-  int    num = 1;
-  int    flag = 0;
-
-  if (fill_serversock(serversock, sizeof(serversock)) < 0)
-    return (EXIT_FAILURE);
-
+  if ((strlen(DEFAULT_PIDDIR) + strlen(SH_INSTALL_NAME) + 1 + 6) > 256)
+    {
+      status = -1;
+    }
+  else
+    {
+      status = sprintf (serversock, _("%s/%s.sock"), 
+			DEFAULT_PIDDIR, SH_INSTALL_NAME);
+    }
+#endif
+
+  if ((status < 0) || (status > 255))
+    {
+      fprintf(stderr, _("ERROR: Path too long (maximum 255): %s/%s.sock\n"), 
+	      DEFAULT_PIDDIR, SH_INSTALL_NAME);
+      return (EXIT_FAILURE);
+    }
 
   while (argc > 1 && argv[num][0] == '-')
@@ -549,30 +448,53 @@
 	{
 	  case 'h':
-	    print_usage_and_exit(argv[0], EXIT_SUCCESS);
-	    break;
+	    usage(argv[0]);
+	    return (EXIT_SUCCESS);
+
 	  case 'v':
 	    ++verbose;
 	    break;
+
 	  case 's':
 	    --argc; ++num;
-	    checknull(argv[0], argv[num]);
-	    checklen(argv[0], argv[num], sizeof(serversock)-1);
-	    safe_copy (serversock, argv[num], sizeof(serversock));
+	    if (argv[num] == NULL || argv[num][0] == '\0') {
+	      usage(argv[0]);
+	      fprintf(stderr, _("ERROR: -s: argument missing\n"));
+	      return (EXIT_FAILURE);
+	    } else {
+	      if (strlen(argv[num]) > 255) 
+		{
+		  fprintf(stderr, _("ERROR: Path too long: %s\n"), argv[num]);
+		  return (EXIT_FAILURE);
+		}
+	      strncpy (serversock, argv[num], 256);
+	      serversock[255] = '\0';
+	    }
 	    break;
+
 	  case 'c':
 	    --argc; ++num;
-	    checknull(argv[0], argv[num]);
-	    checklen(argv[0], argv[num], SH_MAXMSG-1);
-	    if (0 != check_command(argv[num]))
-	      print_usage_and_exit(argv[0], EXIT_FAILURE);
-	    safe_copy(message, argv[num], SH_MAXMSG);
-	    strncat(message, ":", SH_MAXMSG-strlen(message)-1);
-	    message[SH_MAXMSG-1] = '\0';
-	    flag = 1;
+	    if (argv[num] == NULL || argv[num][0] == '\0') {
+	      usage(argv[0]);
+	      fprintf(stderr, _("ERROR: -c: argument missing\n"));
+	      return (EXIT_FAILURE);
+	    } else {
+	      if (strlen(argv[num]) >= SH_MAXMSG) 
+		{
+		  fprintf(stderr, _("ERROR: Command too long: %s\n"), 
+			  argv[num]);
+		  return (EXIT_FAILURE);
+		}
+	      strncpy (message, argv[num], SH_MAXMSG);
+	      message[SH_MAXMSG-1] = '\0';
+	      strncat(message, ":", SH_MAXMSG-strlen(message)-1);
+	      message[SH_MAXMSG-1] = '\0';
+	      flag = 1;
+	    }
 	    break;
+
 	  default:
-	    fprintf(stderr, _("ERROR: unknown option -%c\n\n"), argv[num][1]);
-	    print_usage_and_exit(argv[0], EXIT_FAILURE);
-	    break;
+	    usage(argv[0]);
+	    fprintf(stderr, _("ERROR: unknown option -%c\n"), argv[num][1]);
+	    return (EXIT_FAILURE);
 	}
       --argc; ++num;
@@ -580,35 +502,67 @@
 
   if (flag == 0) /* no command given */
-    print_usage_and_exit(argv[0], EXIT_FAILURE);
+    {
+      usage(argv[0]);
+      return (EXIT_FAILURE);
+    }
 
   if (argc > 1)
     {
-      checklen(argv[0], argv[num], SH_MAXMSG - strlen(message) - 1);
-      strncat (message, argv[num], SH_MAXMSG - strlen(message) - 1);
+      if (strlen(argv[num]) > (SH_MAXMSG - strlen(message) -1)) 
+	{
+	  fprintf(stderr, _("ERROR: Hostname too long: %s\n"), argv[num]);
+	  return (EXIT_FAILURE);
+	}
+      strncat (message, argv[num], SH_MAXMSG -strlen(message) - 1);
       message[SH_MAXMSG-1] = '\0';
     }
   else
     {
-      if (0 == strncmp(message, _("PROBE"), 5) ||
-	  0 == strncmp(message, _("LIST"),  4))
+      if (message[0] == 'P' && message[1] == 'R' &&
+	  message[2] == 'O' && message[3] == 'B' && message[4] == 'E' )
 	{
 	  strncat (message, _("dummy"), SH_MAXMSG -strlen(message) - 1);
 	  message[SH_MAXMSG-1] = '\0';
 	}
+      else if (message[0] == 'L' && message[1] == 'I' &&
+	       message[2] == 'S' && message[3] == 'T')
+	{
+	  strncat (message, _("dummy"), SH_MAXMSG -strlen(message) - 1);
+	  message[SH_MAXMSG-1] = '\0';
+	}
       else
 	{
-	  fprintf(stderr, "%s", _("ERROR: this command requires a hostname\n"));
-	  print_usage_and_exit(argv[0], EXIT_FAILURE);
-	}
-    }
-
-  if (fixup_message(message) < 0)
-    return (EXIT_FAILURE);
+	  fprintf(stderr, "ERROR: this command requires a hostname\n");
+	  usage(argv[0]);
+	  return (EXIT_FAILURE);
+	}
+    }
+
+  fixup_message(message);
+
+  /* OpenBSD wants >= 1024
+   */
+  if (NULL == getcwd(clientcd, 1024))
+    {
+      perror(_("ERROR: getcwd"));
+      return (EXIT_FAILURE);
+    }
+  size = strlen(clientcd) + 1 + strlen(CLIENT) + 6;
+  sockname = malloc (size);
+  if (!sockname)
+    {
+      perror(_("ERROR: main: malloc"));
+      return (EXIT_FAILURE);
+    }
+  sprintf(sockname, _("%s/%s.sock"), clientcd, CLIENT);
+
 
   /* Make the socket.
    */
-  sock = create_unix_socket ();
+  sock = make_named_socket (sockname);
   if (sock < 0)
-    return (EXIT_FAILURE);
+    {
+      return (EXIT_FAILURE);
+    }
 
   /* Set up termination handler.
@@ -624,5 +578,5 @@
   if (status < 0)
     {
-      fprintf(stderr, "%s", _("ERROR: sending command to server failed\n"));
+      fprintf(stderr, _("ERROR: sending command to server failed\n"));
       (void) termination_handler(0);
       return (EXIT_FAILURE);
@@ -631,17 +585,20 @@
   /* Wait for a reply. 
    */
-  if (verbose)
-    {
-      if (0 == strncmp(message, "LIST", 4))
-	fprintf(stdout, "%s", _("# Waiting for listing.\n"));
-      else
-	fprintf(stdout, "%s", _("# Waiting for confirmation.\n"));
-    }
-
+  if (message[0] == 'L' && message[1] == 'I' &&
+      message[2] == 'S' && message[3] == 'T')
+    {
+      if (verbose)
+	fprintf(stdout, _("# Waiting for listing.\n"));
+    }
+  else
+    {
+      if (verbose)
+	fprintf(stdout, _("# Waiting for confirmation.\n"));
+    }
   status = recv_from_server (message);
 
   if (status < 0)
     {
-      fputs(_("ERROR: unexpected or no reply from server.\n"), stderr);
+      fprintf(stderr, _("ERROR: receiving data from server failed.\n"));
       (void) termination_handler(0);
       return (EXIT_FAILURE);
Index: /trunk/src/zAVLTree.c
===================================================================
--- /trunk/src/zAVLTree.c	(revision 584)
+++ /trunk/src/zAVLTree.c	(revision 1)
@@ -32,88 +32,4 @@
 #include <string.h>
 #include "zAVLTree.h"
-
-/* Interface for handling "string only" items rw 2014-06-26
- */
-static zAVLKey zstring_key (void const * arg)
-{
-  return (zAVLKey) arg;
-}
-
-char * dummy_zfree_string;
-#ifdef __clang__
-char * dummy_zfree_str;
-#endif
-
-static void zfree_string (void * inptr)
-{
-#ifdef __clang__
-  dummy_zfree_str = (char *) inptr;
-#else
-  char * str = (char *) inptr;
-#endif
-
-  /* Take the address to circumvent gcc 4.9 optimizer bug */
-  dummy_zfree_string = (char *) &inptr;
-
-#ifdef __clang__
-  dummy_zfree_str[0] = '\0';
-  free (dummy_zfree_str);
-#else
-  str[0] = '\0';
-  free (inptr);
-#endif
-  return;
-}
-void zAVL_string_reset (zAVLTree * tree)
-{
-  if (tree)
-    zAVLFreeTree (tree, zfree_string);
-  return;
-}
-int zAVL_string_set (zAVLTree ** tree, const char * key)
-{
-  if (tree && key)
-    {
-      zAVLTree * itree = (*tree);
-      if (!itree)
-	{
-	  itree = zAVLAllocTree (zstring_key, zAVL_KEY_STRING);
-	  if (!itree) 
-	    {
-	      return -1;
-	    }
-	}
-      *tree = itree;
-      return zAVLInsert (itree, strdup(key));
-    }
-  return -1;
-}
-char * zAVL_string_get (zAVLTree * tree, const char * key)
-{
-  /* zAVLSearch() checks for NULL tree 
-   */
-  if (key)
-    {
-      return ((char *) zAVLSearch (tree, key));
-    }
-  return NULL;
-}
-void zAVL_string_del (zAVLTree * tree, const char * key)
-{
-  /* zAVLSearch() checks for NULL tree 
-   */
-  if (key)
-    {
-      char * item = ((char *) zAVLSearch (tree, key));
-      if (item)
-	{
-	  zAVLDelete(tree, key);
-	  zfree_string(item);
-	}
-    }
-  return;
-}
-
-
 
 /* Wed Nov 23 17:57:42 CET 2005 rw: introduce third argument in
@@ -137,24 +53,4 @@
 #define ZAVL_NO 0
 
-/* The comparison function. Was a macro, but this allows for more
- * flexibility (non-string keys). The key is a (void *) now, and
- * the type is stored in the zAVLTree struct. Oct 21, 2011, rw
- */
-static int zAVLKey_cmp(const zAVLTree * tree, zAVLKey a, zAVLKey b)
-{
-  if (tree->keytype == zAVL_KEY_STRING)
-    {
-      return (strcmp((const char*)a, (const char *)b));
-    }
-  else /* zAVL_KEY_INT */
-    {
-      const int x = *((const int *)a);
-      const int y = *((const int *)b);
-
-      if      (x > y) return  1;
-      else if (x < y) return -1;
-      else return 0;
-    }
-}
 
 /*
@@ -166,9 +62,9 @@
  * was a malloc failure, then NULL is returned.
  */
-zAVLTree *zAVLAllocTree (zAVLKey (*getkey)(void const *item), int keytype)
+zAVLTree *zAVLAllocTree (zAVLKey (*getkey)(void const *item))
 {
   zAVLTree *rc;
 
-  rc = calloc(1, sizeof(zAVLTree));
+  rc = malloc(sizeof(zAVLTree));
   if (rc == NULL)
     return NULL;
@@ -177,5 +73,4 @@
   rc->count = 0;
   rc->getkey = getkey;
-  rc->keytype = keytype;
   return rc;
 }
@@ -214,5 +109,5 @@
   int       ok;
 
-  newnode = calloc(1, sizeof(zAVLNode));
+  newnode = malloc(sizeof(zAVLNode));
   if (newnode == NULL)
     return -1;
@@ -228,5 +123,5 @@
     node = zAVLCloseSearchNode(avltree, newnode->key, &ok);
 
-    if (ok == ZAVL_OK) { /* exists already */
+    if (!zAVLKey_cmp(avltree, node->key, newnode->key)) {
       free(newnode);
       return 3;
@@ -296,5 +191,5 @@
 
   avlnode = zAVLCloseSearchNode(avltree, key, &ok);
-  if (avlnode == NULL || ok == ZAVL_NO) /* does not exist */
+  if (avlnode == NULL || zAVLKey_cmp(avltree, avlnode->key, key))
     return -1;
 
@@ -450,5 +345,5 @@
   depthdiff = R_DEPTH(avlnode) - L_DEPTH(avlnode);
 
-  if (depthdiff <= -2 && avlnode->left) {
+  if (depthdiff <= -2) {
     child = avlnode->left;
 
@@ -468,28 +363,25 @@
     else {
       gchild = child->right;
-      if (gchild)
-	{
-	  avlnode->left = gchild->right;
-	  if (avlnode->left != NULL)
-	    avlnode->left->parent = avlnode;
-	  avlnode->depth = CALC_DEPTH(avlnode);
-	  child->right = gchild->left;
-	  if (child->right != NULL)
-	    child->right->parent = child;
-	  child->depth = CALC_DEPTH(child);
-	  gchild->right = avlnode;
-	  if (gchild->right != NULL)
-	    gchild->right->parent = gchild;
-	  gchild->left = child;
-	  if (gchild->left != NULL)
-	    gchild->left->parent = gchild;
-	  gchild->depth = CALC_DEPTH(gchild);
-	  *superparent = gchild;
-	  gchild->parent = origparent;
-	}
-    }
-  }
-
-  else if (depthdiff >= 2 && avlnode->right) {
+      avlnode->left = gchild->right;
+      if (avlnode->left != NULL)
+        avlnode->left->parent = avlnode;
+      avlnode->depth = CALC_DEPTH(avlnode);
+      child->right = gchild->left;
+      if (child->right != NULL)
+        child->right->parent = child;
+      child->depth = CALC_DEPTH(child);
+      gchild->right = avlnode;
+      if (gchild->right != NULL)
+        gchild->right->parent = gchild;
+      gchild->left = child;
+      if (gchild->left != NULL)
+        gchild->left->parent = gchild;
+      gchild->depth = CALC_DEPTH(gchild);
+      *superparent = gchild;
+      gchild->parent = origparent;
+    }
+  }
+
+  else if (depthdiff >= 2) {
     child = avlnode->right;
 
@@ -509,24 +401,21 @@
     else {
       gchild = child->left;
-      if (gchild)
-	{
-	  avlnode->right = gchild->left;
-	  if (avlnode->right != NULL)
-	    avlnode->right->parent = avlnode;
-	  avlnode->depth = CALC_DEPTH(avlnode);
-	  child->left = gchild->right;
-	  if (child->left != NULL)
-	    child->left->parent = child;
-	  child->depth = CALC_DEPTH(child);
-	  gchild->left = avlnode;
-	  if (gchild->left != NULL)
-	    gchild->left->parent = gchild;
-	  gchild->right = child;
-	  if (gchild->right != NULL)
-	    gchild->right->parent = gchild;
-	  gchild->depth = CALC_DEPTH(gchild);
-	  *superparent = gchild;
-	  gchild->parent = origparent;
-	}
+      avlnode->right = gchild->left;
+      if (avlnode->right != NULL)
+        avlnode->right->parent = avlnode;
+      avlnode->depth = CALC_DEPTH(avlnode);
+      child->left = gchild->right;
+      if (child->left != NULL)
+        child->left->parent = child;
+      child->depth = CALC_DEPTH(child);
+      gchild->left = avlnode;
+      if (gchild->left != NULL)
+        gchild->left->parent = gchild;
+      gchild->right = child;
+      if (gchild->right != NULL)
+        gchild->right->parent = gchild;
+      gchild->depth = CALC_DEPTH(gchild);
+      *superparent = gchild;
+      gchild->parent = origparent;
     }
   }
@@ -551,8 +440,6 @@
   if (avlnode->right)
     zAVLFreeBranch(avlnode->right, freeitem);
-  if (freeitem) {
+  if (freeitem)
     freeitem(avlnode->item);
-    avlnode->item = NULL;
-  }
   free(avlnode);
 }
